diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -4352,112 +631,58 @@ region_model::on_assignment (const gassign *assign, region_model_context *ctxt)
 bool
 region_model::on_call_pre (const gcall *call, region_model_context *ctxt)
 {
-  region_id lhs_rid;
-  tree lhs_type = NULL_TREE;
-  if (tree lhs = gimple_call_lhs (call))
-    {
-      lhs_rid = get_lvalue (lhs, ctxt);
-      lhs_type = TREE_TYPE (lhs);
-    }
-
-  /* Check for uses of poisoned values.
-     For now, special-case "free", to avoid warning about "use-after-free"
-     when "double free" would be more precise.  */
-  if (!is_special_named_call_p (call, "free", 1))
-    for (unsigned i = 0; i < gimple_call_num_args (call); i++)
-      check_for_poison (gimple_call_arg (call, i), ctxt);
-
   bool unknown_side_effects = false;
 
   if (tree callee_fndecl = get_fndecl_for_call (call, ctxt))
     {
+      call_details cd (call, this, ctxt);
+
+      /* The various impl_call_* member functions are implemented
+	 in region-model-impl-calls.cc.
+	 Having them split out into separate functions makes it easier
+	 to put breakpoints on the handling of specific functions.  */
       if (is_named_call_p (callee_fndecl, "malloc", call, 1))
-	{
-	  // TODO: capture size as a svalue?
-	  region_id new_rid = add_new_malloc_region ();
-	  if (!lhs_rid.null_p ())
-	    {
-	      svalue_id ptr_sid
-		= get_or_create_ptr_svalue (lhs_type, new_rid);
-	      set_value (lhs_rid, ptr_sid, ctxt);
-	    }
-	  return false;
-	}
+	return impl_call_malloc (cd);
+      else if (is_named_call_p (callee_fndecl, "calloc", call, 2))
+	return impl_call_calloc (cd);
       else if (is_named_call_p (callee_fndecl, "__builtin_alloca", call, 1))
-	{
-	  region_id frame_rid = get_current_frame_id ();
-	  region_id new_rid
-	    = add_region (new symbolic_region (frame_rid, NULL_TREE, false));
-	  if (!lhs_rid.null_p ())
-	    {
-	      svalue_id ptr_sid
-		= get_or_create_ptr_svalue (lhs_type, new_rid);
-	      set_value (lhs_rid, ptr_sid, ctxt);
-	    }
-	  return false;
-	}
+	return impl_call_alloca (cd);
       else if (gimple_call_builtin_p (call, BUILT_IN_EXPECT)
 	       || gimple_call_builtin_p (call, BUILT_IN_EXPECT_WITH_PROBABILITY)
 	       || gimple_call_internal_p (call, IFN_BUILTIN_EXPECT))
+	return impl_call_builtin_expect (cd);
+      else if (is_named_call_p (callee_fndecl, "memset", call, 3)
+	       || gimple_call_builtin_p (call, BUILT_IN_MEMSET))
 	{
-	  /* __builtin_expect's return value is its initial argument.  */
-	  if (!lhs_rid.null_p ())
-	    {
-	      tree initial_arg = gimple_call_arg (call, 0);
-	      svalue_id sid = get_rvalue (initial_arg, ctxt);
-	      set_value (lhs_rid, sid, ctxt);
-	    }
+	  impl_call_memset (cd);
 	  return false;
 	}
       else if (is_named_call_p (callee_fndecl, "strlen", call, 1))
 	{
-	  region_id buf_rid = deref_rvalue (gimple_call_arg (call, 0), ctxt);
-	  svalue_id buf_sid
-	    = get_region (buf_rid)->get_value (*this, true, ctxt);
-	  if (tree cst_expr = maybe_get_constant (buf_sid))
-	    {
-	      if (TREE_CODE (cst_expr) == STRING_CST
-		  && !lhs_rid.null_p ())
-		{
-		  /* TREE_STRING_LENGTH is sizeof, not strlen.  */
-		  int sizeof_cst = TREE_STRING_LENGTH (cst_expr);
-		  int strlen_cst = sizeof_cst - 1;
-		  tree t_cst = build_int_cst (lhs_type, strlen_cst);
-		  svalue_id result_sid
-		    = get_or_create_constant_svalue (t_cst);
-		  set_value (lhs_rid, result_sid, ctxt);
-		  return false;
-		}
-	    }
-	  /* Otherwise an unknown value.  */
-	}
-      else if (is_named_call_p (callee_fndecl,
-				"__analyzer_dump_num_heap_regions", call, 0))
-	{
-	  /* Handle the builtin "__analyzer_dump_num_heap_regions" by emitting
-	     a warning (for use in DejaGnu tests).  */
-	  int num_heap_regions = 0;
-	  region_id heap_rid = get_root_region ()->ensure_heap_region (this);
-	  unsigned i;
-	  region *region;
-	  FOR_EACH_VEC_ELT (m_regions, i, region)
-	    if (region->get_parent () == heap_rid)
-	      num_heap_regions++;
-	  /* Use quotes to ensure the output isn't truncated.  */
-	  warning_at (call->location, 0,
-		      "num heap regions: %qi", num_heap_regions);
-	  return false;
+	  if (impl_call_strlen (cd))
+	    return false;
 	}
       else if (!fndecl_has_gimple_body_p (callee_fndecl)
-	       && !DECL_PURE_P (callee_fndecl))
+	       && !DECL_PURE_P (callee_fndecl)
+	       && !fndecl_built_in_p (callee_fndecl))
 	unknown_side_effects = true;
     }
   else
     unknown_side_effects = true;
 
-  /* Unknown return value.  */
-  if (!lhs_rid.null_p ())
-    set_to_new_unknown_value (lhs_rid, lhs_type, ctxt);
+  /* Some of the above cases update the lhs of the call based on the
+     return value.  If we get here, it hasn't been done yet, so do that
+     now.  */
+  if (tree lhs = gimple_call_lhs (call))
+    {
+      const region *lhs_region = get_lvalue (lhs, ctxt);
+      // FIXME
+      if (TREE_CODE (lhs) == SSA_NAME)
+	{
+	  const svalue *sval = m_mgr->get_or_create_initial_value (lhs_region);
+	  set_value (lhs_region, sval, ctxt);
+	}
+    }
 
   return unknown_side_effects;
 }
@@ -4474,48 +699,14 @@ region_model::on_call_pre (const gcall *call, region_model_context *ctxt)
 
 void
 region_model::on_call_post (const gcall *call,
-			    bool unknown_side_effects,
-			    region_model_context *ctxt)
+			     bool unknown_side_effects,
+			     region_model_context *ctxt)
 {
-  /* Update for "free" here, after sm-handling.
-
-     If the ptr points to an underlying heap region, delete the region,
-     poisoning pointers to it and regions within it.
-
-     We delay this until after sm-state has been updated so that the
-     sm-handling can transition all of the various casts of the pointer
-     to a "freed" state *before* we delete the related region here.
-
-     This has to be done here so that the sm-handling can use the fact
-     that they point to the same region to establish that they are equal
-     (in region_model::eval_condition_without_cm), and thus transition
-     all pointers to the region to the "freed" state together, regardless
-     of casts.  */
   if (tree callee_fndecl = get_fndecl_for_call (call, ctxt))
     if (is_named_call_p (callee_fndecl, "free", call, 1))
       {
-	tree ptr = gimple_call_arg (call, 0);
-	svalue_id ptr_sid = get_rvalue (ptr, ctxt);
-	svalue *ptr_sval = get_svalue (ptr_sid);
-	if (region_svalue *ptr_to_region_sval
-	    = ptr_sval->dyn_cast_region_svalue ())
-	  {
-	    /* If the ptr points to an underlying heap region, delete it,
-	       poisoning pointers.  */
-	    region_id pointee_rid = ptr_to_region_sval->get_pointee ();
-	    region_id heap_rid = get_root_region ()->ensure_heap_region (this);
-	    if (!pointee_rid.null_p ()
-		&& get_region (pointee_rid)->get_parent () == heap_rid)
-	      {
-		purge_stats stats;
-		delete_region_and_descendents (pointee_rid,
-					       POISON_KIND_FREED,
-					       &stats, ctxt->get_logger ());
-		purge_unused_svalues (&stats, ctxt);
-		validate ();
-		// TODO: do anything with stats?
-	      }
-	  }
+	call_details cd (call, this, ctxt);
+	impl_call_free (cd);
 	return;
       }
 
@@ -4523,84 +714,6 @@ region_model::on_call_post (const gcall *call,
     handle_unrecognized_call (call, ctxt);
 }
 
-/* Helper class for region_model::handle_unrecognized_call, for keeping
-   track of all regions that are reachable, and, of those, which are
-   mutable.  */
-
-class reachable_regions
-{
-public:
-  reachable_regions (region_model *model)
-  : m_model (model), m_reachable_rids (), m_mutable_rids ()
-  {}
-
-  /* Lazily mark RID as being reachable, recursively adding regions
-     reachable from RID.  */
-  void add (region_id rid, bool is_mutable)
-  {
-    gcc_assert (!rid.null_p ());
-
-    unsigned idx = rid.as_int ();
-    /* Bail out if this region is already in the sets at the IS_MUTABLE
-       level of mutability.  */
-    if (!is_mutable && bitmap_bit_p (m_reachable_rids, idx))
-      return;
-    bitmap_set_bit (m_reachable_rids, idx);
-
-    if (is_mutable)
-      {
-	if (bitmap_bit_p (m_mutable_rids, idx))
-	  return;
-	else
-	  bitmap_set_bit (m_mutable_rids, idx);
-      }
-
-    /* If this region's value is a pointer, add the pointee.  */
-    region *reg = m_model->get_region (rid);
-    svalue_id sid = reg->get_value_direct ();
-    svalue *sval = m_model->get_svalue (sid);
-    if (sval)
-      if (region_svalue *ptr = sval->dyn_cast_region_svalue ())
-	{
-	  region_id pointee_rid = ptr->get_pointee ();
-	  /* Use const-ness of pointer type to affect mutability.  */
-	  bool ptr_is_mutable = true;
-	  if (ptr->get_type ()
-	      && TREE_CODE (ptr->get_type ()) == POINTER_TYPE
-	      && TYPE_READONLY (TREE_TYPE (ptr->get_type ())))
-	    ptr_is_mutable = false;
-	  add (pointee_rid, ptr_is_mutable);
-	}
-
-    /* Add descendents of this region.  */
-    region_id_set descendents (m_model);
-    m_model->get_descendents (rid, &descendents, region_id::null ());
-    for (unsigned i = 0; i < m_model->get_num_regions (); i++)
-      {
-	region_id iter_rid = region_id::from_int (i);
-	if (descendents.region_p (iter_rid))
-	  add (iter_rid, is_mutable);
-      }
-  }
-
-  bool mutable_p (region_id rid)
-  {
-    gcc_assert (!rid.null_p ());
-    return bitmap_bit_p (m_mutable_rids, rid.as_int ());
-  }
-
-private:
-  region_model *m_model;
-
-  /* The region ids already seen.  This has to be an auto_bitmap rather than
-     an auto_sbitmap as new regions can be created within the model during
-     the traversal.  */
-  auto_bitmap m_reachable_rids;
-
-  /* The region_ids that can be changed (accessed via non-const pointers).  */
-  auto_bitmap m_mutable_rids;
-};
-
 /* Handle a call CALL to a function with unknown behavior.
 
    Traverse the regions in this model, determining what regions are
@@ -4612,18 +725,18 @@ private:
 
 void
 region_model::handle_unrecognized_call (const gcall *call,
-					region_model_context *ctxt)
+					 region_model_context *ctxt)
 {
   tree fndecl = get_fndecl_for_call (call, ctxt);
 
-  reachable_regions reachable_regions (this);
+  reachable_regions reachable_regs (&m_store, m_mgr);
 
   /* Determine the reachable regions and their mutability.  */
   {
-    /* Globals.  */
-    region_id globals_rid = get_globals_region_id ();
-    if (!globals_rid.null_p ())
-      reachable_regions.add (globals_rid, true);
+    /* Add globals and regions that already escaped in previous
+       unknown calls.  */
+    m_store.for_each_cluster (reachable_regions::init_cluster_cb,
+			      &reachable_regs);
 
     /* Params that are pointers.  */
     tree iter_param_types = NULL_TREE;
@@ -4641,62 +754,75 @@ region_model::handle_unrecognized_call (const gcall *call,
 	  }
 
 	tree parm = gimple_call_arg (call, arg_idx);
-	svalue_id parm_sid = get_rvalue (parm, ctxt);
-	svalue *parm_sval = get_svalue (parm_sid);
-	if (parm_sval)
-	  if (region_svalue *parm_ptr = parm_sval->dyn_cast_region_svalue ())
-	    {
-	      region_id pointee_rid = parm_ptr->get_pointee ();
-	      bool is_mutable = true;
-	      if (param_type
-		  && TREE_CODE (param_type) == POINTER_TYPE
-		  &&  TYPE_READONLY (TREE_TYPE (param_type)))
-		is_mutable = false;
-	      reachable_regions.add (pointee_rid, is_mutable);
-	    }
+	const svalue *parm_sval = get_rvalue (parm, ctxt);
+	reachable_regs.handle_parm (parm_sval, param_type);
 	// FIXME: what about compound parms that contain ptrs?
       }
   }
 
-  /* OK: we now have all reachable regions.
-     Set them all to new unknown values.  */
-  for (unsigned i = 0; i < get_num_regions (); i++)
+  /* Purge sm-state for the svalues that were reachable,
+     both in non-mutable and mutable form.  */
+  for (svalue_set::iterator iter
+	 = reachable_regs.begin_reachable_svals ();
+       iter != reachable_regs.end_reachable_svals (); ++iter)
     {
-      region_id iter_rid = region_id::from_int (i);
-      if (reachable_regions.mutable_p (iter_rid))
-	{
-	  region *reg = get_region (iter_rid);
+      const svalue *sval = (*iter);
+      ctxt->on_unknown_change (sval, false);
+    }
+  for (svalue_set::iterator iter
+	 = reachable_regs.begin_mutable_svals ();
+       iter != reachable_regs.end_mutable_svals (); ++iter)
+    {
+      const svalue *sval = (*iter);
+      ctxt->on_unknown_change (sval, true);
+    }
 
-	  /* Purge any sm-state for any underlying svalue.  */
-	  svalue_id curr_sid = reg->get_value_direct ();
-	  if (!curr_sid.null_p ())
-	    ctxt->on_unknown_change (curr_sid);
+  /* Mark any clusters that have escaped.  */
+  reachable_regs.mark_escaped_clusters ();
 
-	  set_to_new_unknown_value (iter_rid,
-				    reg->get_type (),
-				    ctxt);
-	}
-    }
+  /* Update bindings for all clusters that have escaped, whether above,
+     or previously.  */
+  m_store.on_unknown_fncall (call, m_mgr->get_store_manager ());
+}
 
-  /* Purge sm-state for any remaining svalues that point to regions that
-     were reachable.  This helps suppress leak false-positives.
+/* Traverse the regions in this model, determining what regions are
+   reachable from the store and populating *OUT.
 
-     For example, if we had a malloc call that was cast to a "foo *" type,
-     we could have a temporary void * for the result of malloc which has its
-     own svalue, not reachable from the function call, but for which the
-     "foo *" svalue was reachable.  If we don't purge it, the temporary will
-     be reported as a leak.  */
-  int i;
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    if (region_svalue *ptr = svalue->dyn_cast_region_svalue ())
-      {
-	region_id pointee_rid = ptr->get_pointee ();
-	if (reachable_regions.mutable_p (pointee_rid))
-	  ctxt->on_unknown_change (svalue_id::from_int (i));
-      }
+   If EXTRA_SVAL is non-NULL, treat it as an additional "root"
+   for reachability (for handling return values from functions when
+   analyzing return of the only function on the stack).
+
+   Find svalues that haven't leaked.    */
+
+void
+region_model::get_reachable_svalues (svalue_set *out,
+				     const svalue *extra_sval)
+{
+  reachable_regions reachable_regs (&m_store, m_mgr);
+
+  /* Add globals and regions that already escaped in previous
+     unknown calls.  */
+  m_store.for_each_cluster (reachable_regions::init_cluster_cb,
+			    &reachable_regs);
+
+  if (extra_sval)
+    reachable_regs.handle_sval (extra_sval);
+
+  /* Get regions for locals that have explicitly bound values.  */
+  for (store::cluster_map_t::iterator iter = m_store.begin ();
+       iter != m_store.end (); ++iter)
+    {
+      const region *base_reg = (*iter).first;
+      if (const region *parent = base_reg->get_parent_region ())
+	if (parent->get_kind () == RK_FRAME)
+	  reachable_regs.add (base_reg, false);
+    }
 
-  validate ();
+  /* Populate *OUT based on the values that were reachable.  */
+  for (svalue_set::iterator iter
+	 = reachable_regs.begin_reachable_svals ();
+       iter != reachable_regs.end_reachable_svals (); ++iter)
+    out->add (*iter);
 }
 
 /* Update this model for the RETURN_STMT, using CTXT to report any
@@ -4723,50 +849,48 @@ void
 region_model::on_setjmp (const gcall *call, const exploded_node *enode,
 			 region_model_context *ctxt)
 {
-  region_id buf_rid = deref_rvalue (gimple_call_arg (call, 0), ctxt);
-  region *buf = get_region (buf_rid);
+  const svalue *buf_ptr = get_rvalue (gimple_call_arg (call, 0), ctxt);
+  const region *buf_reg = deref_rvalue (buf_ptr, gimple_call_arg (call, 0),
+					 ctxt);
 
-  /* Create a setjmp_svalue for this call and store it in BUF_RID's region.  */
-  if (buf)
+  /* Create a setjmp_svalue for this call and store it in BUF_REG's
+     region.  */
+  if (buf_reg)
     {
       setjmp_record r (enode, call);
-      svalue *sval = new setjmp_svalue (r, buf->get_type ());
-      svalue_id new_sid = add_svalue (sval);
-      set_value (buf_rid, new_sid, ctxt);
+      const svalue *sval
+	= m_mgr->get_or_create_setjmp_svalue (r, buf_reg->get_type ());
+      set_value (buf_reg, sval, ctxt);
     }
 
   /* Direct calls to setjmp return 0.  */
   if (tree lhs = gimple_call_lhs (call))
     {
       tree zero = build_int_cst (TREE_TYPE (lhs), 0);
-      svalue_id new_sid = get_or_create_constant_svalue (zero);
-      region_id lhs_rid = get_lvalue (lhs, ctxt);
-      set_value (lhs_rid, new_sid, ctxt);
+      const svalue *new_sval = m_mgr->get_or_create_constant_svalue (zero);
+      const region *lhs_reg = get_lvalue (lhs, ctxt);
+      set_value (lhs_reg, new_sval, ctxt);
     }
 }
 
 /* Update this region_model for rewinding from a "longjmp" at LONGJMP_CALL
    to a "setjmp" at SETJMP_CALL where the final stack depth should be
-   SETJMP_STACK_DEPTH.  Purge any stack frames, potentially reporting on
-   leaks to CTXT.  */
+   SETJMP_STACK_DEPTH.  Pop any stack frames.  Leak detection is *not*
+   done, and should be done by the caller.  */
 
 void
 region_model::on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
-			  int setjmp_stack_depth,
-			  region_model_context *ctxt)
+			   int setjmp_stack_depth, region_model_context *ctxt)
 {
   /* Evaluate the val, using the frame of the "longjmp".  */
   tree fake_retval = gimple_call_arg (longjmp_call, 1);
-  svalue_id fake_retval_sid = get_rvalue (fake_retval, ctxt);
+  const svalue *fake_retval_sval = get_rvalue (fake_retval, ctxt);
 
   /* Pop any frames until we reach the stack depth of the function where
      setjmp was called.  */
   gcc_assert (get_stack_depth () >= setjmp_stack_depth);
   while (get_stack_depth () > setjmp_stack_depth)
-    {
-      /* Don't purge unused svalues yet, as we're using fake_retval_sid.  */
-      pop_frame (region_id::null (), false, NULL, ctxt);
-    }
+    pop_frame (NULL, NULL, ctxt);
 
   gcc_assert (get_stack_depth () == setjmp_stack_depth);
 
@@ -4775,29 +899,32 @@ region_model::on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
     {
       /* Passing 0 as the val to longjmp leads to setjmp returning 1.  */
       tree t_zero = build_int_cst (TREE_TYPE (fake_retval), 0);
-      svalue_id zero_sid = get_or_create_constant_svalue (t_zero);
-      tristate eq_zero = eval_condition (fake_retval_sid, EQ_EXPR, zero_sid);
+      const svalue *zero_sval = m_mgr->get_or_create_constant_svalue (t_zero);
+      tristate eq_zero = eval_condition (fake_retval_sval, EQ_EXPR, zero_sval);
       /* If we have 0, use 1.  */
       if (eq_zero.is_true ())
 	{
 	  tree t_one = build_int_cst (TREE_TYPE (fake_retval), 1);
-	  svalue_id one_sid = get_or_create_constant_svalue (t_one);
-	  fake_retval_sid = one_sid;
+	  const svalue *one_sval
+	    = m_mgr->get_or_create_constant_svalue (t_one);
+	  fake_retval_sval = one_sval;
 	}
       else
 	{
 	  /* Otherwise note that the value is nonzero.  */
-	  m_constraints->add_constraint (fake_retval_sid, NE_EXPR, zero_sid);
+	  m_constraints->add_constraint (fake_retval_sval, NE_EXPR, zero_sval);
 	}
 
-      region_id lhs_rid = get_lvalue (lhs, ctxt);
-      set_value (lhs_rid, fake_retval_sid, ctxt);
-    }
+      /* Decorate the return value from setjmp as being unmergeable,
+	 so that we don't attempt to merge states with it as zero
+	 with states in which it's nonzero, leading to a clean distinction
+	 in the exploded_graph betweeen the first return and the second
+	 return.  */
+      fake_retval_sval = m_mgr->get_or_create_unmergeable (fake_retval_sval);
 
-  /* Now that we've assigned the fake_retval, we can purge the unused
-     svalues, which could detect leaks.  */
-  purge_unused_svalues (NULL, ctxt, NULL);
-  validate ();
+      const region *lhs_reg = get_lvalue (lhs, ctxt);
+      set_value (lhs_reg, fake_retval_sval, ctxt);
+    }
 }
 
 /* Update this region_model for a phi stmt of the form
@@ -4806,7 +933,7 @@ region_model::on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
 
 void
 region_model::handle_phi (const gphi *phi,
-			  tree lhs, tree rhs, bool is_back_edge,
+			  tree lhs, tree rhs,
 			  region_model_context *ctxt)
 {
   /* For now, don't bother tracking the .MEM SSA names.  */
@@ -4815,22 +942,9 @@ region_model::handle_phi (const gphi *phi,
       if (VAR_DECL_IS_VIRTUAL_OPERAND (var))
 	return;
 
-  svalue_id rhs_sid = get_rvalue (rhs, ctxt);
+  const svalue *rhs_sval = get_rvalue (rhs, ctxt);
 
-  if (is_back_edge && get_svalue (rhs_sid)->get_kind () != SK_UNKNOWN)
-    {
-      /* If we have a back edge, we probably have a loop.
-	 Use an unknown value, to avoid effectively unrolling the
-	 loop.
-	 To terminate, we need to avoid generating a series of
-	 models with an unbounded monotonically increasing number of
-	 redundant unknown values; hence we need to purge svalues
-	 before inserting the state into the exploded graph, to
-	 collect unused svalues.  */
-      set_to_new_unknown_value (get_lvalue (lhs, ctxt), TREE_TYPE (lhs), ctxt);
-    }
-  else
-    set_value (get_lvalue (lhs, ctxt), rhs_sid, ctxt);
+  set_value (get_lvalue (lhs, ctxt), rhs_sval, ctxt);
 
   if (ctxt)
     ctxt->on_phi (phi, rhs);
@@ -4841,7 +955,7 @@ region_model::handle_phi (const gphi *phi,
    Get the id of the region for PV within this region_model,
    emitting any diagnostics to CTXT.  */
 
-region_id
+const region *
 region_model::get_lvalue_1 (path_var pv, region_model_context *ctxt)
 {
   tree expr = pv.m_tree;
@@ -4851,68 +965,45 @@ region_model::get_lvalue_1 (path_var pv, region_model_context *ctxt)
   switch (TREE_CODE (expr))
     {
     default:
-      return make_region_for_unexpected_tree_code (ctxt, expr,
-						   dump_location_t ());
+      return m_mgr->get_region_for_unexpected_tree_code (ctxt, expr,
+							 dump_location_t ());
 
     case ARRAY_REF:
       {
 	tree array = TREE_OPERAND (expr, 0);
 	tree index = TREE_OPERAND (expr, 1);
-#if 0
-	// TODO: operands 2 and 3, if present:
-	gcc_assert (TREE_OPERAND (expr, 2) == NULL_TREE);
-	gcc_assert (TREE_OPERAND (expr, 3) == NULL_TREE);
-#endif
-
-	region_id array_rid = get_lvalue (array, ctxt);
-	svalue_id index_sid = get_rvalue (index, ctxt);
-	region *base_array_reg = get_region (array_rid);
-	array_region *array_reg  = base_array_reg->dyn_cast_array_region ();
-	if (!array_reg)
-	  {
-	    /* Normally, array_rid ought to refer to an array_region, since
-	       array's type will be ARRAY_TYPE.  However, if we have an
-	       unexpected tree code for array, we could have a
-	       symbolic_region here.  If so, we're in error-handling. */
-	    gcc_assert (base_array_reg->get_type () == NULL_TREE);
-	    return make_region_for_unexpected_tree_code (ctxt, expr,
-							 dump_location_t ());
-	  }
-	return array_reg->get_element (this, array_rid, index_sid, ctxt);
-      }
-      break;
 
-    case BIT_FIELD_REF:
-      {
-	/* For now, create a view, as if a cast, ignoring the bit positions.  */
-	tree obj = TREE_OPERAND (expr, 0);
-	return get_or_create_view (get_lvalue (obj, ctxt), TREE_TYPE (expr),
-				   ctxt);
-      };
+	const region *array_reg = get_lvalue (array, ctxt);
+	const svalue *index_sval = get_rvalue (index, ctxt);
+	return m_mgr->get_element_region (array_reg,
+					  TREE_TYPE (TREE_TYPE (array)),
+					  index_sval);
+      }
       break;
 
     case MEM_REF:
       {
 	tree ptr = TREE_OPERAND (expr, 0);
 	tree offset = TREE_OPERAND (expr, 1);
-	svalue_id ptr_sid = get_rvalue (ptr, ctxt);
-	svalue_id offset_sid = get_rvalue (offset, ctxt);
-	return get_or_create_mem_ref (TREE_TYPE (expr), ptr_sid,
-				      offset_sid, ctxt);
+	const svalue *ptr_sval = get_rvalue (ptr, ctxt);
+	const svalue *offset_sval = get_rvalue (offset, ctxt);
+	const region *star_ptr = deref_rvalue (ptr_sval, ptr, ctxt);
+	return m_mgr->get_offset_region (star_ptr,
+					 TREE_TYPE (expr),
+					 offset_sval);
       }
       break;
 
+    case FUNCTION_DECL:
+      return m_mgr->get_region_for_fndecl (expr);
+
+    case LABEL_DECL:
+      return m_mgr->get_region_for_label (expr);
+
     case VAR_DECL:
       /* Handle globals.  */
       if (is_global_var (expr))
-	{
-	  region_id globals_rid
-	    = get_root_region ()->ensure_globals_region (this);
-	  map_region *globals = get_region<map_region> (globals_rid);
-	  region_id var_rid = globals->get_or_create (this, globals_rid, expr,
-						      TREE_TYPE (expr), ctxt);
-	  return var_rid;
-	}
+	return m_mgr->get_region_for_global (expr);
 
       /* Fall through.  */
 
@@ -4925,86 +1016,25 @@ region_model::get_lvalue_1 (path_var pv, region_model_context *ctxt)
 		    || TREE_CODE (expr) == VAR_DECL
 		    || TREE_CODE (expr) == RESULT_DECL);
 
-	int stack_depth = pv.m_stack_depth;
-	stack_region *stack = get_root_region ()->get_stack_region (this);
-	gcc_assert (stack);
-	region_id frame_rid = stack->get_frame_rid (stack_depth);
-	frame_region *frame = get_region <frame_region> (frame_rid);
-	gcc_assert (frame);
-	region_id child_rid = frame->get_or_create (this, frame_rid, expr,
-						    TREE_TYPE (expr), ctxt);
-	return child_rid;
-      }
-
-    case COMPONENT_REF:
-      {
-	/* obj.field  */
-	tree obj = TREE_OPERAND (expr, 0);
-	tree field = TREE_OPERAND (expr, 1);
-	tree obj_type = TREE_TYPE (obj);
-	if (TREE_CODE (obj_type) != RECORD_TYPE
-	    && TREE_CODE (obj_type) != UNION_TYPE)
-	  return make_region_for_unexpected_tree_code (ctxt, obj_type,
-						       dump_location_t ());
-	region_id obj_rid = get_lvalue (obj, ctxt);
-	region_id struct_or_union_rid
-	  = get_or_create_view (obj_rid, TREE_TYPE (obj), ctxt);
-	return get_field_region (struct_or_union_rid, field, ctxt);
-      }
-      break;
-
-    case CONST_DECL:
-      {
-	tree cst_type = TREE_TYPE (expr);
-	region_id cst_rid = add_region_for_type (m_root_rid, cst_type, ctxt);
-	if (tree value = DECL_INITIAL (expr))
-	  {
-	    svalue_id sid = get_rvalue (value, ctxt);
-	    get_region (cst_rid)->set_value (*this, cst_rid, sid, ctxt);
-	  }
-	return cst_rid;
-      }
-      break;
-
-    case STRING_CST:
-      {
-	tree cst_type = TREE_TYPE (expr);
-	array_region *cst_region = new array_region (m_root_rid, cst_type);
-	region_id cst_rid = add_region (cst_region);
-	svalue_id cst_sid = get_or_create_constant_svalue (expr);
-	cst_region->set_value (*this, cst_rid, cst_sid, ctxt);
-	return cst_rid;
+	int stack_index = pv.m_stack_depth;
+	const frame_region *frame = get_frame_at_index (stack_index);
+	gcc_assert (frame);
+	return frame->get_region_for_local (m_mgr, expr);
       }
-      break;
 
-    case NOP_EXPR:
-    case VIEW_CONVERT_EXPR:
+    case COMPONENT_REF:
       {
+	/* obj.field  */
 	tree obj = TREE_OPERAND (expr, 0);
-	return get_or_create_view (get_lvalue (obj, ctxt), TREE_TYPE (expr),
-				   ctxt);
-      };
+	tree field = TREE_OPERAND (expr, 1);
+	const region *obj_reg = get_lvalue (obj, ctxt);
+	return m_mgr->get_field_region (obj_reg, field);
+      }
       break;
-    }
-}
 
-/* If we see a tree code we don't know how to handle, rather than
-   ICE or generate bogus results, create a dummy region, and notify
-   CTXT so that it can mark the new state as being not properly
-   modelled.  The exploded graph can then stop exploring that path,
-   since any diagnostics we might issue will have questionable
-   validity.  */
-
-region_id
-region_model::make_region_for_unexpected_tree_code (region_model_context *ctxt,
-						    tree t,
-						    const dump_location_t &loc)
-{
-  gcc_assert (ctxt);
-  region_id new_rid
-    = add_region (new symbolic_region (m_root_rid, NULL_TREE, false));
-  ctxt->on_unexpected_tree_code (t, loc);
-  return new_rid;
+    case STRING_CST:
+      return m_mgr->get_region_for_string (expr);
+    }
 }
 
 /* Assert that SRC_TYPE can be converted to DST_TYPE as a no-op.  */
@@ -5013,28 +1043,28 @@ static void
 assert_compat_types (tree src_type, tree dst_type)
 {
   if (src_type && dst_type && !VOID_TYPE_P (dst_type))
-    gcc_checking_assert (useless_type_conversion_p (src_type, dst_type));
+    if (!(useless_type_conversion_p (src_type, dst_type)))
+      internal_error ("incompatible types: %qT and %qT", src_type, dst_type);
 }
 
-/* Get the id of the region for PV within this region_model,
+/* Get the region for PV within this region_model,
    emitting any diagnostics to CTXT.  */
 
-region_id
+const region *
 region_model::get_lvalue (path_var pv, region_model_context *ctxt)
 {
   if (pv.m_tree == NULL_TREE)
-    return region_id::null ();
+    return NULL;
 
-  region_id result_rid = get_lvalue_1 (pv, ctxt);
-  assert_compat_types (get_region (result_rid)->get_type (),
-		       TREE_TYPE (pv.m_tree));
-  return result_rid;
+  const region *result_reg = get_lvalue_1 (pv, ctxt);
+  assert_compat_types (result_reg->get_type (), TREE_TYPE (pv.m_tree));
+  return result_reg;
 }
 
-/* Get the region_id for EXPR within this region_model (assuming the most
+/* Get the region for EXPR within this region_model (assuming the most
    recent stack frame if it's a local).  */
 
-region_id
+const region *
 region_model::get_lvalue (tree expr, region_model_context *ctxt)
 {
   return get_lvalue (path_var (expr, get_stack_depth () - 1), ctxt);
@@ -5045,7 +1075,7 @@ region_model::get_lvalue (tree expr, region_model_context *ctxt)
    Get the value of PV within this region_model,
    emitting any diagnostics to CTXT.  */
 
-svalue_id
+const svalue *
 region_model::get_rvalue_1 (path_var pv, region_model_context *ctxt)
 {
   gcc_assert (pv.m_tree);
